#ifndef ALGORITHM_HPP
#define ALGORITHM_HPP

#include <string>
#include <vector>

typedef struct Edge Edge;
typedef struct Vertex Vertex;

struct Edge {
    Vertex* destination;
    int weight;
    Edge(Vertex* destination, int weight);
};

struct Vertex {
    int nodeNumber;
    std::vector<Edge> edges;
    void AddEdge(Vertex* destination, int weight);
};

struct Graph {
    int nodeCount;
    std::vector<Vertex> vertices;
    Graph(void);
    void AddEdge(int source, int destination, int weight);
    void PrintGraph(void);
};

Graph ReadInGraph(std::string fileLocation);
void PrintSolution(std::vector<Vertex*> solution);

void UCBFS(Graph graph, int start);
std::vector<Vertex*> BFS(Graph graph, int start, int end);
std::vector<Vertex*> DFS(Graph graph, int start, int end);

#endif 
